# ThreadingUtilities

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSIMD.github.io/ThreadingUtilities.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaSIMD.github.io/ThreadingUtilities.jl/dev)
[![Continuous Integration](https://github.com/JuliaSIMD/ThreadingUtilities.jl/workflows/CI/badge.svg)](https://github.com/JuliaSIMD/ThreadingUtilities.jl/actions?query=workflow%3ACI)
[![Continuous Integration (Julia nightly)](https://github.com/JuliaSIMD/ThreadingUtilities.jl/workflows/CI%20(Julia%20nightly)/badge.svg)](https://github.com/JuliaSIMD/ThreadingUtilities.jl/actions?query=workflow%3A%22CI+%28Julia+nightly%29%22)
[![Coverage](https://codecov.io/gh/JuliaSIMD/ThreadingUtilities.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSIMD/ThreadingUtilities.jl)

Utilities for low overhead threading in Julia.

Please see the [documentation](https://JuliaSIMD.github.io/ThreadingUtilities.jl/stable).

If you're using Windows, please note that Windows often allocates memory when neither Mac or Linux do. I do not know why. If you can help diagnose/fix the problem, please take a look at `count_allocated()` in `/test/staticarrays.jl`.

If you are trying to mix code relying on `ThreadingUtitlies.jl` (e.g. `LoopVectorization.jl`'s threaded code, `Polyester.jl`, or `Octavian.jl`) with other threaded code, you can use `ThreadingUtilities.sleep_all_tasks()` to put `ThreadingUtilities`'s tasks to sleep before switching from `ThreadingUtilities` to the other threaded code. Manually putting `ThreadingUtilities`'s tasks to sleep in this way should stop them from interfearing.

function _string_to_bool(s::AbstractString)
    b = tryparse(Bool, s)
    if b isa Nothing
        return false
    else
        return b::Bool
    end
end

function _is_suppress_warning()
    s = get(ENV, "SUPPRESS_THREADINGUTILITIES_WARNING", "")
    b = _string_to_bool(s)::Bool
    return b
end

function _is_julia_exclusive()
    s = strip(get(ENV, "JULIA_EXCLUSIVE", "0"))
    # From https://github.com/JuliaLang/julia/blob/efc986003356be5daea6ccd9e38008de961c18aa/doc/src/manual/environment-variables.md:
    # If set to anything besides 0, then Julia's thread policy is consistent
    # with running on a dedicated machine: the master thread is on proc 0, and
    # threads are affinitized. Otherwise, Julia lets the operating system handle
    # thread policy.
    i = tryparse(Int, s)
    if isempty(s)
        return false
    elseif s == "0" || i == 0
        return false
    else
        return true
    end
end

function _print_exclusivity_warning()
    is_julia_exclusive = _is_julia_exclusive()::Bool
    if !is_julia_exclusive
        suppress_warning = _is_suppress_warning()::Bool
        if !suppress_warning
            msg = string(
                "The JULIA_EXCLUSIVE environment variable is not set to 1. ",
                "Therefore, the kernel is allowed to move threads to different ",
                "cores. We recommend that you set the JULIA_EXCLUSIVE ",
                "environment variable to 1. To suppress this warning, set the ",
                "SUPPRESS_THREADINGUTILITIES_WARNING environment ",
                "variable to 1.",
            )
            @debug(msg)
        end
    end
    return nothing
end

using StaticArrays, ThreadingUtilities, BenchmarkTools
struct MulStaticArray{P} end
function (::MulStaticArray{P})(p::Ptr{UInt}) where {P}
  _, (ptry,ptrx) = ThreadingUtilities.load(p, P, 2*sizeof(UInt))
  unsafe_store!(ptry, unsafe_load(ptrx) * 2.7)
  ThreadingUtilities._atomic_store!(p, ThreadingUtilities.SPIN)
  nothing
end
@generated function mul_staticarray_ptr(::A, ::B) where {A,B}
    c = MulStaticArray{Tuple{A,B}}()
    :(@cfunction($c, Cvoid, (Ptr{UInt},)))
end

@inline function setup_mul_svector!(p, y::Base.RefValue{T}, x::Base.RefValue{T}) where {T}
    py = Base.unsafe_convert(Ptr{T}, y)
    px = Base.unsafe_convert(Ptr{T}, x)
    fptr = mul_staticarray_ptr(py, px)
    offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
    ThreadingUtilities.store!(p, (py,px), offset)
end

@inline function launch_thread_mul_svector(tid, y, x)
    ThreadingUtilities.launch(setup_mul_svector!, tid, y, x)
end

function waste_time(a, b)
  s = a * b'
  for _ ∈ 1:0
    s += a * b'
  end
  s
end

function mul_svector_threads(a::T, b::T, c::T) where {T}
    ra = Ref(a)
    rb = Ref(b)
    rc = Ref(c)
    rx = Ref{T}()
    ry = Ref{T}()
    rz = Ref{T}()
    GC.@preserve ra rb rc rx ry rz begin
        launch_thread_mul_svector(1, rx, ra)
        launch_thread_mul_svector(2, ry, rb)
        launch_thread_mul_svector(3, rz, rc)
        w = waste_time(a, b)
        ThreadingUtilities.wait(1)
        ThreadingUtilities.wait(2)
        ThreadingUtilities.wait(3)
    end
    rx[], ry[], rz[], w
end
function count_allocated()
  a = @SVector rand(16);
  b = @SVector rand(16);
  c = @SVector rand(16);
  @ballocated(mul_svector_threads($a,$b,$c))
end


@testset "SVector Test" begin
  a = @SVector rand(16);
  b = @SVector rand(16);
  c = @SVector rand(16);
  w,x,y,z = mul_svector_threads(a, b, c)
  count_allocated()
  if !Sys.iswindows()
    @test count_allocated() == 0
  else
    @show count_allocated()
  end
  @test w == a*2.7
  @test x == b*2.7
  @test y == c*2.7
  @test z ≈ waste_time(a, b)
  A = @SMatrix rand(7,9);
  B = @SMatrix rand(7,9);
  C = @SMatrix rand(7,9);
  Wans = A*2.7; Xans = B*2.7; Yans = C*2.7;
  for i ∈ 1:100 # repeat rapdily
    C, A, B = A, B, C
    W,X,Y,Z = mul_svector_threads(A, B, C)
    iseven(i) && ThreadingUtilities.sleep_all_tasks()
    (Yans, Wans, Xans) = Wans, Xans, Yans
    @test W == Wans
    @test X == Xans
    @test Y == Yans
    @test Z ≈ waste_time(A, B)
  end
end

struct Copy{P} end
function (::Copy{P})(p::Ptr{UInt}) where {P}
  _, (ptry, ptrx, N) = ThreadingUtilities.load(p, P, 2 * sizeof(UInt))
  N > 0 || throw("This function throws if N == 0 for testing purposes.")
  @simd ivdep for n ∈ 1:N
    unsafe_store!(ptry, unsafe_load(ptrx, n), n)
  end
  ThreadingUtilities._atomic_store!(p, ThreadingUtilities.SPIN)
end
@generated function copy_ptr(::A, ::B) where {A,B}
  c = Copy{Tuple{A,B,Int}}()
  quote
    @cfunction($c, Cvoid, (Ptr{UInt},))
  end
end
function setup_copy!(p, y, x)
  N = length(y)
  @assert length(x) == N
  py = pointer(y)
  px = pointer(x)
  fptr = copy_ptr(py, px)
  offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
  ThreadingUtilities.store!(p, (py, px, N), offset)
end

@inline launch_thread_copy!(tid, y, x) = ThreadingUtilities.launch(setup_copy!, tid, y, x)

function test_copy(tid, N = 100_000)
  a = rand(N)
  b = rand(N)
  c = rand(N)
  x = similar(a) .= NaN
  y = similar(b) .= NaN
  z = similar(c) .= NaN
  GC.@preserve a b c x y z begin
    launch_thread_copy!(tid, x, a)
    yield()
    @assert !ThreadingUtilities.wait(tid)
    launch_thread_copy!(tid, y, b)
    yield()
    @assert !ThreadingUtilities.wait(tid)
    launch_thread_copy!(tid, z, c)
    yield()
    @assert !ThreadingUtilities.wait(ThreadingUtilities.taskpointer(tid))
  end
  @test a == x
  @test b == y
  @test c == z
end

@testset "ThreadingUtilities.jl" begin
  for tid ∈ eachindex(ThreadingUtilities.TASKS)
    @test unsafe_load(Ptr{UInt32}(ThreadingUtilities.taskpointer(tid))) == 0x00000001
  end
  @test all(eachindex(ThreadingUtilities.TASKS)) do tid
    ThreadingUtilities.load(
      ThreadingUtilities.taskpointer(tid),
      ThreadingUtilities.ThreadState,
    ) === ThreadingUtilities.WAIT
  end
  @test all(eachindex(ThreadingUtilities.TASKS)) do tid
    ThreadingUtilities._atomic_load(
      reinterpret(Ptr{UInt32}, ThreadingUtilities.taskpointer(tid)),
    ) === reinterpret(UInt32, ThreadingUtilities.WAIT)
  end
  foreach(test_copy, eachindex(ThreadingUtilities.TASKS))

  x = rand(UInt, 3)
  GC.@preserve x begin
    ThreadingUtilities._atomic_store!(pointer(x), zero(UInt))
    @test ThreadingUtilities._atomic_xchg!(pointer(x), ThreadingUtilities.WAIT) ==
          ThreadingUtilities.TASK
    @test ThreadingUtilities._atomic_umax!(pointer(x), ThreadingUtilities.TASK) ==
          ThreadingUtilities.WAIT
    @test ThreadingUtilities._atomic_umax!(pointer(x), ThreadingUtilities.SPIN) ==
          ThreadingUtilities.WAIT
    @test ThreadingUtilities.load(pointer(x), ThreadingUtilities.ThreadState) ==
          ThreadingUtilities.SPIN
  end
  # Make all tasks error
  for tid ∈ eachindex(ThreadingUtilities.TASKS)
    launch_thread_copy!(tid, Float64[], Float64[])
  end
  sleep(1)
  @test all(istaskfailed, ThreadingUtilities.TASKS)
  # Test that `wait` reports the error for each task
  for tid in eachindex(ThreadingUtilities.TASKS)
    @test_throws TaskFailedException ThreadingUtilities.wait(tid)
  end
  # Test that none of the tasks are in the failed state
  @test !any(istaskfailed, ThreadingUtilities.TASKS)
  # test copy on the reinitialized tasks
  foreach(test_copy, eachindex(ThreadingUtilities.TASKS))
end

@testset "Internals" begin
    @test ThreadingUtilities.store!(pointer(UInt[]), (), 1) == 1
    @test ThreadingUtilities.store!(pointer(UInt[]), nothing, 1) == 1
    x = zeros(UInt, 100);
    GC.@preserve x begin
        t1 = (1.0, C_NULL, Val(7), (3, UInt(17)), (pointer(x), strides(x)))
        @test ThreadingUtilities.store!(pointer(x), t1, 0) === mapreduce(sizeof, +, t1)
        @test ThreadingUtilities.store!(pointer(x), Val(0), 0) == 0
        @test ThreadingUtilities.load(pointer(x), typeof(t1), 0) === (mapreduce(sizeof, +, t1), t1)
        @test ThreadingUtilities.load(pointer(x), Val{0}, 0) === (0, Val(0))
        @test ThreadingUtilities.store!(pointer(x), 0xb502916f%UInt, 72) == 72 + sizeof(Int)
        @test ThreadingUtilities.load(pointer(x), UInt, 72) == (72 + sizeof(Int),0xb502916f%UInt)
        nt1 = (;a = 1.0)
        @test ThreadingUtilities.store!(pointer(x), nt1, 0) === sizeof(nt1)
        @test ThreadingUtilities.load(pointer(x), typeof(nt1), 0) === (sizeof(nt1), nt1)
    end
end

using InteractiveUtils: versioninfo

versioninfo()

@info("Running tests with $(Threads.nthreads()) threads")

function is_coverage()
    return !iszero(Base.JLOptions().code_coverage)
end

const coverage = is_coverage()

@info("Code coverage is $(coverage ? "enabled" : "disabled")")

@testset "warnings" begin
    @testset "exclusivity warning" begin
        withenv("JULIA_DEBUG" => "all", "SUPPRESS_THREADINGUTILITIES_WARNING" => "0", "JULIA_EXCLUSIVE" => "") do
            @test (@test_logs (:debug, "The JULIA_EXCLUSIVE environment variable is not set to 1. Therefore, the kernel is allowed to move threads to different cores. We recommend that you set the JULIA_EXCLUSIVE environment variable to 1. To suppress this warning, set the SUPPRESS_THREADINGUTILITIES_WARNING environment variable to 1.") match_mode=:any ThreadingUtilities._print_exclusivity_warning()) isa Nothing
        end
        withenv("SUPPRESS_THREADINGUTILITIES_WARNING" => "1", "JULIA_EXCLUSIVE" => "") do
            @test ThreadingUtilities._print_exclusivity_warning() isa Nothing
        end
        withenv("JULIA_DEBUG" => "all", "SUPPRESS_THREADINGUTILITIES_WARNING" => "0", "JULIA_EXCLUSIVE" => "0") do
            @test (@test_logs (:debug, "The JULIA_EXCLUSIVE environment variable is not set to 1. Therefore, the kernel is allowed to move threads to different cores. We recommend that you set the JULIA_EXCLUSIVE environment variable to 1. To suppress this warning, set the SUPPRESS_THREADINGUTILITIES_WARNING environment variable to 1.") match_mode=:any ThreadingUtilities._print_exclusivity_warning()) isa Nothing
        end
        withenv("SUPPRESS_THREADINGUTILITIES_WARNING" => "1", "JULIA_EXCLUSIVE" => "0") do
            @test ThreadingUtilities._print_exclusivity_warning() isa Nothing
        end
    end

    @testset "utility functions" begin
        @test ThreadingUtilities._string_to_bool("true")
        @test ThreadingUtilities._string_to_bool("1")
        @test !ThreadingUtilities._string_to_bool("false")
        @test !ThreadingUtilities._string_to_bool("0")
        @test !ThreadingUtilities._string_to_bool("")
    end
end

module ThreadingUtilities
if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@max_methods 1
end

using ManualMemory: load, store!

"""
  pause()

For use in spin-and-wait loops, like spinlocks.
"""
@inline pause() = ccall(:jl_cpu_pause, Cvoid, ())

if VERSION ≥ v"1.6.0-DEV.674"
  @inline assume(b::Bool)::Cvoid = Base.llvmcall(("    declare void @llvm.assume(i1)\n\n    define void @entry(i8) alwaysinline {\n    top:\n        %b = trunc i8 %0 to i1\ncall void @llvm.assume(i1 %b)\nret void\n    }\n", "entry"), Cvoid, Tuple{Bool}, b)
else
  @inline assume(b::Bool)::Cvoid = Base.llvmcall(("declare void @llvm.assume(i1)", "%b = trunc i8 %0 to i1\ncall void @llvm.assume(i1 %b)\nret void"), Cvoid, Tuple{Bool}, b)
end

@enum ThreadState::UInt32 begin
  TASK = 0   # 0: task available
  WAIT = 1   # 1: waiting
  SPIN = 2   # 2: spinning
end
const TASKS = Task[]
const LINESPACING = 256 # maximum cache-line size among contemporary CPUs.
const THREADBUFFERSIZE = 512
const THREADPOOL = UInt[]
const THREADPOOLPTR =  Ref{Ptr{UInt}}(C_NULL);

include("atomics.jl")
include("threadtasks.jl")
include("warnings.jl")

function initialize_task(tid)
  _atomic_store!(taskpointer(tid), WAIT)
  t = Task(ThreadTask(taskpointer(tid)));
  t.sticky = true # create and pin
  # set to tid, we have tasks 2...nthread, from 1-based ind perspective
  ccall(:jl_set_task_tid, Cvoid, (Any, Cint), t, tid % Cint)
  TASKS[tid] = t
  return nothing
end

function __init__()
  _print_exclusivity_warning()
  sys_threads::Int = parse(Bool, get(ENV, "GITHUB_ACTIONS", "false")) ? Threads.nthreads() : (Sys.CPU_THREADS)::Int
  nt = min(Threads.nthreads(), sys_threads) - 1
  resize!(THREADPOOL, (THREADBUFFERSIZE ÷ sizeof(UInt)) * nt + (LINESPACING ÷ sizeof(UInt)) - 1)
  copyto!(THREADPOOL, zero(UInt))
  # align to LINESPACING boundary, and then subtract THREADBUFFERSIZE to make the pointer 1-indexed
  THREADPOOLPTR[] = reinterpret(Ptr{UInt}, (reinterpret(UInt, pointer(THREADPOOL))+LINESPACING-1) & (-LINESPACING)) - THREADBUFFERSIZE
  resize!(TASKS, nt)
  foreach(initialize_task, 1:nt)
end

end # module

using ThreadingUtilities
using Documenter

makedocs(;
    modules=[ThreadingUtilities],
    authors="Chris Elrod <elrodc@gmail.com> and contributors",
    repo="https://github.com/JuliaSIMD/ThreadingUtilities.jl/blob/{commit}{path}#L{line}",
    sitename="ThreadingUtilities.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://JuliaSIMD.github.io/ThreadingUtilities.jl",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
        "Public API" => "public-api.md",
        "Internals (Private)" => "internals.md",
    ]
)

deploydocs(;
    repo="github.com/JuliaSIMD/ThreadingUtilities.jl",
)

@testset "THREADPOOL" begin
  @test isconst(ThreadingUtilities, :THREADPOOL) # test that ThreadingUtilities.THREADPOOL is a constant
  @test ThreadingUtilities.THREADPOOL isa Vector{UInt}
  @test eltype(ThreadingUtilities.THREADPOOL) === UInt
  sys_threads::Int = parse(Bool, get(ENV, "GITHUB_ACTIONS", "false")) ? Threads.nthreads() : (Sys.CPU_THREADS)::Int
  @test length(ThreadingUtilities.THREADPOOL) == (ThreadingUtilities.THREADBUFFERSIZE÷sizeof(UInt)) * (min(Threads.nthreads(),sys_threads) - 1) + (256 ÷ sizeof(UInt)) - 1
end

include("testsetup.jl")

include("test-suite-preamble.jl")

include("internals.jl")
include("threadingutilities.jl")
if Threads.nthreads() > 3
  include("staticarrays.jl")
end
include("threadpool.jl")
include("warnings.jl")

include("aqua.jl") # run the Aqua.jl tests last

for (ityp,jtyp) ∈ [("i8", UInt8), ("i16", UInt16), ("i32", UInt32), ("i64", UInt64), ("i128", UInt128)]
    @eval begin
        @inline function _atomic_load(ptr::Ptr{$jtyp})
            Base.llvmcall($(
                @static if VERSION >= v"1.12-DEV"
                    # use opaque pointers #53
                    """
                    %v = load atomic $(ityp), ptr %0 acquire, align $(Base.gc_alignment(jtyp))
                    ret $(ityp) %v
                    """
                else
                    """
                    %p = inttoptr i$(8sizeof(Int)) %0 to $(ityp)*
                    %v = load atomic $(ityp), $(ityp)* %p acquire, align $(Base.gc_alignment(jtyp))
                    ret $(ityp) %v
                    """
                end
            ), $jtyp, Tuple{Ptr{$jtyp}}, ptr)
        end
        @inline function _atomic_store!(ptr::Ptr{$jtyp}, x::$jtyp)
            Base.llvmcall($(
                @static if VERSION >= v"1.12-DEV"
                    """
                    store atomic $(ityp) %1, ptr %0 release, align $(Base.gc_alignment(jtyp))
                    ret void
                    """
                else
                    """
                    %p = inttoptr i$(8sizeof(Int)) %0 to $(ityp)*
                    store atomic $(ityp) %1, $(ityp)* %p release, align $(Base.gc_alignment(jtyp))
                    ret void
                    """
                end
            ), Cvoid, Tuple{Ptr{$jtyp}, $jtyp}, ptr, x)
        end
        @inline function _atomic_cas_cmp!(ptr::Ptr{$jtyp}, cmp::$jtyp, newval::$jtyp)
            Base.llvmcall($(
                @static if VERSION >= v"1.12-DEV"
                    """
                    %c = cmpxchg ptr %0, $(ityp) %1, $(ityp) %2 acq_rel acquire
                    %bit = extractvalue { $ityp, i1 } %c, 1
                    %bool = zext i1 %bit to i8
                    ret i8 %bool
                    """
                else
                    """
                    %p = inttoptr i$(8sizeof(Int)) %0 to $(ityp)*
                    %c = cmpxchg $(ityp)* %p, $(ityp) %1, $(ityp) %2 acq_rel acquire
                    %bit = extractvalue { $ityp, i1 } %c, 1
                    %bool = zext i1 %bit to i8
                    ret i8 %bool
                    """
                end
            ), Bool, Tuple{Ptr{$jtyp}, $jtyp, $jtyp}, ptr, cmp, newval)
        end
    end
end

"""
Operations supported by `atomicrmw`.

- Julia v1.11 use [libLLVM-16](https://releases.llvm.org/16.0.0/docs/LangRef.html#atomicrmw-instruction)
"""
const atomicrmw_ops = [
    "xchg", "add", "sub",
    "and", "nand", "or", "xor",
    "max", "min", "umax", "umin",
    # "fadd", "fsub", 
    # "fmax", "fmin",
    # "uinc_wrap", "udec_wrap",  # Need LLVM 16: VERSION >= v"1.11"
]
for op ∈ atomicrmw_ops
    f = Symbol("_atomic_", op, '!')
    for (ityp,jtyp) ∈ [("i8", UInt8), ("i16", UInt16), ("i32", UInt32), ("i64", UInt64), ("i128", UInt128)]
        @eval begin
            # Do inplace `$(op)` for `*ptr` and `x` atomically, return the old value of `*ptr`.
            @inline function $f(ptr::Ptr{$jtyp}, x::$jtyp)
                Base.llvmcall($(
                    @static if VERSION >= v"1.12-DEV"
                        """
                        %v = atomicrmw $(op) ptr %0, $(ityp) %1 acq_rel
                        ret $(ityp) %v
                        """
                    else
                        """
                        %p = inttoptr i$(8sizeof(Int)) %0 to $(ityp)*
                        %v = atomicrmw $op $(ityp)* %p, $(ityp) %1 acq_rel
                        ret $(ityp) %v
                        """
                    end
                ), $jtyp, Tuple{Ptr{$jtyp}, $jtyp}, ptr, x)
            end
        end
    end
    @eval begin
        @inline function $f(ptr::Ptr{UInt}, x::ThreadState)
            reinterpret(ThreadState, $f(reinterpret(Ptr{UInt32}, ptr), reinterpret(UInt32, x)))
        end
    end
end

@inline _atomic_state(ptr::Ptr{UInt}) = reinterpret(ThreadState, _atomic_load(reinterpret(Ptr{UInt32}, ptr)))
@inline _atomic_store!(ptr::Ptr{UInt}, x::ThreadState) = _atomic_store!(reinterpret(Ptr{UInt32}, ptr), reinterpret(UInt32, x))
@inline function _atomic_cas_cmp!(ptr::Ptr{UInt}, cmp::ThreadState, newval::ThreadState)
    _atomic_cas_cmp!(reinterpret(Ptr{UInt32}, ptr), reinterpret(UInt32, cmp), reinterpret(UInt32, newval))
end

struct ThreadTask
  p::Ptr{UInt}
end
Base.pointer(tt::ThreadTask) = tt.p

@inline taskpointer(tid::T) where {T} = THREADPOOLPTR[] + tid * (THREADBUFFERSIZE % T)

@inline function _call(p::Ptr{UInt})
  fptr = load(p + sizeof(UInt), Ptr{Cvoid})
  assume(fptr ≠ C_NULL)
  ccall(fptr, Cvoid, (Ptr{UInt},), p)
end
@inline function launch(f::F, tid::Integer, args::Vararg{Any,K}) where {F,K}
  p = taskpointer(tid)
  f(p, args...)
  # exchange must happen atomically, to prevent it from switching to `WAIT` after reading
  state = _atomic_xchg!(p, TASK)
  state == WAIT && wake_thread!(tid)
  return nothing
end

function (tt::ThreadTask)()
  p = pointer(tt)
  max_wait = one(UInt32) << 20
  wait_counter = max_wait
  GC.@preserve THREADPOOL begin
    while true
      if _atomic_state(p) == TASK
        _call(p)
        wait_counter = zero(UInt32)
        continue
      end
      pause()
      if (wait_counter += one(UInt32)) > max_wait
        wait_counter = zero(UInt32)
        _atomic_cas_cmp!(p, SPIN, WAIT) && Base.wait()
      end
    end
  end
end

function _sleep(p::Ptr{UInt})
  _atomic_store!(p, WAIT)
  Base.wait()
  return nothing
end

function sleep_all_tasks()
  fptr = @cfunction(_sleep, Cvoid, (Ptr{UInt},))
  for tid ∈ eachindex(TASKS)
    p = taskpointer(tid)
    ThreadingUtilities.store!(p, fptr, sizeof(UInt))
    _atomic_cas_cmp!(p, SPIN, TASK)
  end
  for tid ∈ eachindex(TASKS)
    wait(tid)
  end
end

# 1-based tid, pushes into task 2-nthreads()
@noinline function wake_thread!(_tid::T) where {T<:Integer}
  tid = _tid % Int
  tidp1 = tid + one(tid)
  @static if VERSION >= v"1.13-"
    assume(unsigned(length(Base.Workqueues())) > unsigned(tid))
  else
    assume(unsigned(length(Base.Workqueues)) > unsigned(tid))
  end
  assume(unsigned(length(TASKS)) > unsigned(tidp1))
  @inbounds push!(Base.Workqueues[tidp1], TASKS[tid])
  ccall(:jl_wakeup_thread, Cvoid, (Int16,), tid % Int16)
end

@noinline function checktask(tid)
  t = TASKS[tid]
  if istaskfailed(t)
    initialize_task(tid)
    throw(TaskFailedException(t))
  end
  yield()
  false
end

# Like checktask, but without throwing errors.
# This is used in Polyester.reset_threads!().
@noinline function reinit_task(tid)
  t = TASKS[tid]
  if istaskfailed(t)
    initialize_task(tid)
  end
  yield()
end

# 1-based tid
@inline tasktid(p::Ptr{UInt}) = (p - THREADPOOLPTR[]) ÷ (THREADBUFFERSIZE)
@inline wait(tid::Integer) = wait(taskpointer(tid), tid)
@inline wait(p::Ptr{UInt}) = wait(p, tasktid(p))
@inline function wait(p::Ptr{UInt}, tid)
  counter = 0x00000000
  while _atomic_state(p) == TASK
    pause()
    if ((counter += 0x00000001) > 0x00010000)
      checktask(tid) && return true
    end
  end
  false
end

```@meta
CurrentModule = ThreadingUtilities
```

# ThreadingUtilities

[ThreadingUtilities](https://github.com/JuliaSIMD/ThreadingUtilities.jl)
provides utilities for low overhead threading in Julia.

The source code for this package is available in the
[GitHub repository](https://github.com/JuliaSIMD/ThreadingUtilities.jl).
